



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS开发ARC内存管理技术要点</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS开发ARC内存管理技术要点</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 06:42:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文来源于我个人的ARC学习笔记，旨在通过简明扼要的方式总结出iOS开发中ARC(Automatic Reference Counting，自动引用计数)内存管理技术的要点，所以不会涉及全部细节。这篇文章不是一篇标准的ARC使用教程，并假定读者已经对ARC有了一定了解和使用经验。详细的关于ARC的信息请参见苹果的<a href="https://developer.apple.com/library/ios/releasenotes/ObjectiveC/RN-TransitioningToARC/Introduction/Introduction.html" rel="external nofollow noreferrer">官方文档</a>与网上的其他教程：）</p>
<p>本文的主要内容：</p>
<ul><li><p>ARC的本质</p></li>
<li><p>ARC的开启与关闭</p></li>
<li><p>ARC的修饰符</p></li>
<li><p>ARC与Block</p></li>
<li><p>ARC与Toll-Free Bridging</p></li></ul>
<h2>技术交流新QQ群：414971585</h2>
<h2>ARC的本质</h2>
<hr />
<p>ARC是编译器（时）特性，而不是运行时特性，更不是垃圾回收器(GC)。</p>
<blockquote><p>Automatic Reference Counting (ARC) is a compiler-level feature that simplifies the process of managing object lifetimes (memory management) in Cocoa applications.</p></blockquote>
<p>ARC只是相对于MRC（Manual Reference Counting或称为非ARC，下文中我们会一直使用MRC来指代非ARC的管理方式）的一次改进，但它和之前的技术本质上没有区别。具体信息可以参考<a href="http://clang.llvm.org/docs/AutomaticReferenceCounting.html" rel="external nofollow noreferrer">ARC编译器官方文档</a>。</p>
<h2>ARC的开启与关闭</h2>
<hr />
<p>不同于XCode4可以在创建工程时选择关闭ARC，XCode5在创建的工程是默认开启ARC，没有可以关闭ARC的选项。</p>
<p>如果需要对特定文件开启或关闭ARC，可以在工程选项中选择Targets -&gt; Compile Phases -&gt; Compile Sources，在里面找到对应文件，添加flag:</p>
<ul><li><p>打开ARC：-fobjc-arc</p></li></ul>
<ul><li><p>关闭ARC：-fno-objc-arc</p></li></ul>
<p>如图：</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/image/20150206/1423188104210850.png" /></p>
<h2>ARC的修饰符</h2>
<hr />
<p>ARC主要提供了4种修饰符，他们分别是:__strong,__weak,__autoreleasing,__unsafe_unretained。</p>
<h3><strong>__strong</strong></h3>
<p>表示引用为强引用。对应在定义property时的"strong"。所有对象只有当没有任何一个强引用指向时，才会被释放。</p>
<p>注意：如果在声明引用时不加修饰符，那么引用将默认是强引用。当需要释放强引用指向的对象时，需要将强引用置nil。</p>
<h3><strong>__weak</strong></h3>
<p>表示引用为弱引用。对应在定义property时用的"weak"。弱引用不会影响对象的释放，即只要对象没有任何强引用指向，即使有100个弱引用对象指向也没用，该对象依然会被释放。不过好在，对象在被释放的同时，指向它的弱引用会自动被置nil，这个技术叫zeroing weak pointer。这样有效得防止无效指针、野指针的产生。__weak一般用在delegate关系中防止循环引用或者用来修饰指向由Interface Builder编辑与生成的UI控件。</p>
<h3><strong>__autoreleasing</strong></h3>
<p>表示在autorelease pool中自动释放对象的引用，和MRC时代autorelease的用法相同。定义property时不能使用这个修饰符，任何一个对象的property都不应该是autorelease型的。</p>
<p>一个常见的误解是，在ARC中没有autorelease，因为这样一个&ldquo;自动释放&rdquo;看起来好像有点多余。这个误解可能源自于将ARC的&ldquo;自动&rdquo;和autorelease&ldquo;自动&rdquo;的混淆。其实你只要看一下每个iOS App的main.m文件就能知道，autorelease不仅好好的存在着，并且变得更fashion了：不需要再手工被创建，也不需要再显式得调用[drain]方法释放内存池。</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/image/20150206/1423188105868349.png" /></p>
<p>以下两行代码的意义是相同的。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>NSString&nbsp;*str&nbsp;=&nbsp;[[[NSString&nbsp;alloc]&nbsp;initWithFormat:@</code><code>"hehe"</code><code>]&nbsp;autorelease];&nbsp;</code><code>//&nbsp;MRC</code></div>
<div><code>NSString&nbsp;*__autoreleasing&nbsp;str&nbsp;=&nbsp;[[NSString&nbsp;alloc]&nbsp;initWithFormat:@</code><code>"hehe"</code><code>];&nbsp;</code><code>//&nbsp;ARC</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>这里关于autoreleasepool就不做展开了，详细地信息可以参考官方文档或者其他文章。</p>
<p>__autoreleasing在ARC中主要用在参数传递返回值（out-parameters）和引用传递参数（pass-by-reference）的情况下。</p>
<blockquote><p><code>__autoreleasing</code>&nbsp;is used to denote arguments that are passed by reference (<code>id *</code>) and are autoreleased on return.</p></blockquote>
<p>比如常用的NSError的使用：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>NSError&nbsp;*__autoreleasing&nbsp;error;&nbsp;</code></div>
<div><code>?&nbsp;(![data&nbsp;writeToFile:filename&nbsp;options:NSDataWritingAtomic&nbsp;error:&amp;error])&nbsp;</code></div>
<div><code>?{&nbsp;</code></div>
<div><code>　　NSLog(,&nbsp;error);&nbsp;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>（在上面的writeToFile方法中error参数的类型为(NSError *__autoreleasing *)）</p>
<p>注意，如果你的error定义为了strong型，那么，编译器会帮你隐式地做如下事情，保证最终传入函数的参数依然是个__autoreleasing类型的引用。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
</td>
<td>
<div>
<div><code>NSError&nbsp;*error;&nbsp;</code></div>
<div><code>NSError&nbsp;*__autoreleasing&nbsp;tempError&nbsp;=&nbsp;error;&nbsp;</code><code>//&nbsp;编译器添加&nbsp;</code></div>
<div><code>if</code>&nbsp;<code>(![data&nbsp;writeToFile:filename&nbsp;options:NSDataWritingAtomic&nbsp;error:&amp;tempError])&nbsp;</code></div>
<div><code>?{&nbsp;</code></div>
<div><code>　　error&nbsp;=&nbsp;tempError;&nbsp;</code><code>//&nbsp;编译器添加&nbsp;</code></div>
<div><code>　　NSLog(@</code><code>"Error:&nbsp;%@"</code><code>,&nbsp;error);&nbsp;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>所以为了提高效率，避免这种情况，我们一般在定义error的时候将其（老老实实地=。=）声明为__autoreleasing类型的：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>NSError&nbsp;*__autoreleasing&nbsp;error;</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在这里，加上__autoreleasing之后，相当于在MRC中对返回值error做了如下事情：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>*error&nbsp;=&nbsp;[[[NSError&nbsp;alloc]&nbsp;init]&nbsp;autorelease];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>*error指向的对象在创建出来后，被放入到了autoreleasing pool中，等待使用结束后的自动释放，函数外error的使用者并不需要关心*error指向对象的释放。</p>
<p>另外一点，在ARC中，所有这种指针的指针 （NSError **）的函数参数如果不加修饰符，编译器会默认将他们认定为__autoreleasing类型。</p>
<p>比如下面的两段代码是等同的：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>-&nbsp;(NSString&nbsp;*)doSomething:(NSNumber&nbsp;**)value</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;do&nbsp;something&nbsp;&nbsp;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>-&nbsp;(NSString&nbsp;*)doSomething:(NSNumber&nbsp;*&nbsp;__autoreleasing&nbsp;*)value</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;do&nbsp;something&nbsp;&nbsp;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>除非你显式得给value声明了__strong，否则value默认就是__autoreleasing的。</p>
<p>最后一点，某些类的方法会隐式地使用自己的autorelease pool，在这种时候使用__autoreleasing类型要特别小心。</p>
<p>比如NSDictionary的[enumerateKeysAndObjectsUsingBlock]方法：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)loopThroughDictionary:(NSDictionary&nbsp;*)dict&nbsp;error:(NSError&nbsp;**)error</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[dict&nbsp;enumerateKeysAndObjectsUsingBlock:^(id&nbsp;key,&nbsp;id&nbsp;obj,&nbsp;BOOL&nbsp;*stop){</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;do&nbsp;stuff&nbsp;&nbsp;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(there&nbsp;is&nbsp;some&nbsp;error&nbsp;&amp;&amp;&nbsp;error&nbsp;!=&nbsp;nil)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>*error&nbsp;=&nbsp;[NSError&nbsp;errorWithDomain:@</code><code>"MyError"</code>&nbsp;<code>?code:1&nbsp;userInfo:nil];</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>?</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}];</code></div>
<div><code>?}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>会隐式地创建一个autorelease pool，上面代码实际类似于：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)loopThroughDictionary:(NSDictionary&nbsp;*)dict&nbsp;error:(NSError&nbsp;**)error</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[dict&nbsp;enumerateKeysAndObjectsUsingBlock:^(id&nbsp;key,&nbsp;id&nbsp;obj,&nbsp;BOOL&nbsp;*stop){</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>@autoreleasepool&nbsp;&nbsp;</code><code>//&nbsp;被隐式创建</code></div>
<div><code>　　　　　　{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(there&nbsp;is&nbsp;some&nbsp;error&nbsp;&amp;&amp;&nbsp;error&nbsp;!=&nbsp;nil)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>*error&nbsp;=&nbsp;[NSError&nbsp;errorWithDomain:@</code><code>"MyError"</code>&nbsp;<code>?code:1&nbsp;userInfo:nil];</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>?&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}];</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;*error&nbsp;在这里已经被dict的做枚举遍历时创建的autorelease&nbsp;pool释放掉了&nbsp;：(&nbsp;&nbsp;</code></div>
<div><code>?}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>为了能够正常的使用*error，我们需要一个strong型的临时引用，在dict的枚举Block中是用这个临时引用，保证引用指向的对象不会在出了dict的枚举Block后被释放，正确的方式如下：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)loopThroughDictionary:(NSDictionary&nbsp;*)dict&nbsp;error:(NSError&nbsp;**)error</code></div>
<div><code>{</code></div>
<div><code>　　__block&nbsp;NSError*&nbsp;tempError;&nbsp;</code><code>//&nbsp;加__block保证可以在Block内被修改&nbsp;&nbsp;</code></div>
<div><code>　　[dict&nbsp;enumerateKeysAndObjectsUsingBlock:^(id&nbsp;key,&nbsp;id&nbsp;obj,&nbsp;BOOL&nbsp;*stop)</code></div>
<div><code>　　{&nbsp;</code></div>
<div><code>　　　　</code><code>if</code>&nbsp;<code>(there&nbsp;is&nbsp;some&nbsp;error)&nbsp;</code></div>
<div><code>　　　　{&nbsp;</code></div>
<div><code>　　　　　　*tempError&nbsp;=&nbsp;[NSError&nbsp;errorWithDomain:@</code><code>"MyError"</code>&nbsp;<code>?code:1&nbsp;userInfo:nil];&nbsp;</code></div>
<div><code>　　　　}&nbsp;?&nbsp;</code></div>
<div>&nbsp;</div>
<div><code>　　}]&nbsp;</code></div>
<div>&nbsp;</div>
<div><code>　　</code><code>if</code>&nbsp;<code>(error&nbsp;!=&nbsp;nil)&nbsp;</code></div>
<div><code>　　{&nbsp;</code></div>
<div><code>　　　　*error&nbsp;=&nbsp;tempError;&nbsp;</code></div>
<div><code>　　}&nbsp;?</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong>__unsafe_unretained</strong></h3>
<p>ARC是在iOS 5引入的，而这个修饰符主要是为了在ARC刚发布时兼容iOS 4以及版本更低的设备，因为这些版本的设备没有weak pointer system，简单的理解这个系统就是我们上面讲weak时提到的，能够在weak引用指向对象被释放后，把引用值自动设为nil的系统。这个修饰符在定义property时对应的是"unsafe_unretained"，实际可以将它理解为MRC时代的assign：纯粹只是将引用指向对象，没有任何额外的操作，在指向对象被释放时依然原原本本地指向原来被释放的对象（所在的内存区域）。所以非常不安全。</p>
<p>现在可以完全忽略掉这个修饰符了，因为iOS 4早已退出历史舞台很多年。</p>
<h3><strong>*使用修饰符的正确姿势（方式=。=）</strong></h3>
<p>这可能是很多人都不知道的一个问题，包括之前的我，但却是一个特别要注意的问题。</p>
<p>苹果的文档中明确地写道：</p>
<blockquote><p>You should decorate variables correctly. When using qualifiers in an object variable declaration,</p>
<p>the correct format is:</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>ClassName&nbsp;*&nbsp;qualifier&nbsp;variableName;</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div></blockquote>
<p>按照这个说明，要定义一个weak型的NSString引用，它的写法应该是：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>NSString&nbsp;*&nbsp;__weak&nbsp;str&nbsp;=&nbsp;@</code><code>"hehe"</code><code>;&nbsp;</code><code>//&nbsp;正确！</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>而不应该是：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>__weak&nbsp;NSString&nbsp;*str&nbsp;=&nbsp;@</code><code>"hehe"</code><code>;&nbsp;&nbsp;</code><code>//&nbsp;错误！</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>我相信很多人都和我一样，从开始用ARC就一直用上面那种错误的写法。</p>
<p>那这里就有疑问了，既然文档说是错误的，为啥编译器不报错呢？文档又解释道：</p>
<blockquote><p>Other variants are technically incorrect but are &ldquo;forgiven&rdquo; by the compiler. To understand the issue, see<a href="http://cdecl.org/" rel="external nofollow noreferrer">http://cdecl.org/</a>.</p></blockquote>
<p>好吧，看来是苹果爸爸（=。=）考虑到很多人会用错，所以在编译器这边贴心地帮我们忽略并处理掉了这个错误：）虽然不报错，但是我们还是应该按照正确的方式去使用这些修饰符，如果你以前也常常用错误的写法，那看到这里记得以后不要这么写了，哪天编译器怒了，再不支持错误的写法，就要郁闷了。</p>
<h3><strong>栈中指针默认值为nil</strong></h3>
<p>无论是被strong，weak还是autoreleasing修饰，声明在栈中的指针默认值都会是nil。所有这类型的指针不用再初始化的时候置nil了。虽然好习惯是最重要的，但是这个特性更加降低了&ldquo;野指针&rdquo;出现的可能性。</p>
<p>在ARC中，以下代码会输出null而不是crash:)</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>-&nbsp;(void)myMethod&nbsp;</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSString&nbsp;*name;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSLog(@</code><code>"name:&nbsp;%@"</code><code>,&nbsp;name);</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h2>ARC与Block</h2>
<hr />
<p>在MRC时代，Block会隐式地对进入其作用域内的对象（或者说被Block捕获的指针指向的对象）加retain，来确保Block使用到该对象时，能够正确的访问。</p>
<p>这件事情在下面代码展示的情况中要更加额外小心。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
</td>
<td>
<div>
<div><code>MyViewController&nbsp;*myController&nbsp;=&nbsp;[[MyViewController&nbsp;alloc]&nbsp;init&hellip;];</code></div>
<div>&nbsp;</div>
<div><code>//&nbsp;隐式地调用[myController&nbsp;retain];造成循环引用</code></div>
<div><code>myController.completionHandler&nbsp;=&nbsp;&nbsp;^(NSInteger&nbsp;result)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;</code><code>[myController&nbsp;dismissViewControllerAnimated:YES&nbsp;completion:nil];</code></div>
<div><code>};</code></div>
<div>&nbsp;</div>
<div><code>[self&nbsp;presentViewController:myController&nbsp;animated:YES&nbsp;completion:^{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;</code><code>[myController&nbsp;release];&nbsp;</code><code>//&nbsp;注意，这里调用[myController&nbsp;release];是在MRC中的一个常规写法，并不能解决上面循环引用的问题</code></div>
<div><code>}];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在这段代码中，myController的completionHandler调用了myController的方法[dismissViewController...]，这时completionHandler会对myController做retain操作。而我们知道，myController对completionHandler也至少有一个retain（一般准确讲是copy），这时就出现了在内存管理中最糟糕的情况：循环引用！简单点说就是：myController retain了completionHandler，而completionHandler也retain了myController。循环引用导致了myController和completionHandler最终都不能被释放。我们在delegate关系中，对delegate指针用weak就是为了避免这种问题。</p>
<p>不过好在，编译器会及时地给我们一个警告，提醒我们可能会发生这类型的问题：</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/image/20150206/1423188106858574.png" /></p>
<p>对这种情况，我们一般用如下方法解决：给要进入Block的指针加一个__block修饰符。</p>
<p>这个__block在MRC时代有两个作用：</p>
<ul><li><p>说明变量可改</p></li>
<li><p>说明指针指向的对象不做这个隐式的retain操作</p></li></ul>
<p>一个变量如果不加__block，是不能在Block里面修改的，不过这里有一个例外：static的变量和全局变量不需要加__block就可以在Block中修改。</p>
<p>使用这种方法，我们对代码做出修改，解决了循环引用的问题：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>MyViewController&nbsp;*&nbsp;__block&nbsp;myController&nbsp;=&nbsp;[[MyViewController&nbsp;alloc]&nbsp;init&hellip;];</code></div>
<div><code>//&nbsp;...</code></div>
<div><code>myController.completionHandler&nbsp;=&nbsp;&nbsp;^(NSInteger&nbsp;result)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[myController&nbsp;dismissViewControllerAnimated:YES&nbsp;completion:nil];</code></div>
<div><code>};</code></div>
<div><code>//之后正常的release或者retain</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在ARC引入后，没有了retain和release等操作，情况也发生了改变：在任何情况下，__block修饰符的作用只有上面的第一条：说明变量可改。即使加上了__block修饰符，一个被block捕获的强引用也依然是一个强引用。这样在ARC下，如果我们还按照MRC下的写法，completionHandler对myController有一个强引用，而myController对completionHandler有一个强引用，这依然是循环引用，没有解决问题：（</p>
<p>于是我们还需要对原代码做修改。简单的情况我们可以这样写：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>__block&nbsp;MyViewController&nbsp;*&nbsp;myController&nbsp;=&nbsp;[[MyViewController&nbsp;alloc]&nbsp;init&hellip;];</code></div>
<div><code>//&nbsp;...</code></div>
<div><code>myController.completionHandler&nbsp;=&nbsp;&nbsp;^(NSInteger&nbsp;result)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[myController&nbsp;dismissViewControllerAnimated:YES&nbsp;completion:nil];</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>myController&nbsp;=&nbsp;nil;&nbsp;&nbsp;</code><code>//&nbsp;注意这里，保证了block结束myController强引用的解除</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在completionHandler之后将myController指针置nil，保证了completionHandler对myController强引用的解除，不过也同时解除了myController对myController对象的强引用。这种方法过于简单粗暴了，在大多数情况下，我们有更好的方法。</p>
<p>这个更好的方法就是使用weak。（或者为了考虑iOS4的兼容性用unsafe_unretained，具体用法和weak相同，考虑到现在iOS4设备可能已经绝迹了，这里就不讲这个方法了）（关于这个方法的本质我们后面会谈到）</p>
<p>为了保证completionHandler这个Block对myController没有强引用，我们可以定义一个临时的弱引用weakMyViewController来指向原myController的对象，并把这个弱引用传入到Block内，这样就保证了Block对myController持有的是一个弱引用，而不是一个强引用。如此，我们继续修改代码：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>MyViewController&nbsp;*myController&nbsp;=&nbsp;[[MyViewController&nbsp;alloc]&nbsp;init&hellip;];</code></div>
<div><code>//&nbsp;...</code></div>
<div><code>MyViewController&nbsp;*&nbsp;__weak&nbsp;weakMyViewController&nbsp;=&nbsp;myController;</code></div>
<div><code>myController.completionHandler&nbsp;=&nbsp;&nbsp;^(NSInteger&nbsp;result)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[weakMyViewController&nbsp;dismissViewControllerAnimated:YES&nbsp;completion:nil];</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>这样循环引用的问题就解决了，但是却不幸地引入了一个新的问题：由于传入completionHandler的是一个弱引用，那么当myController指向的对象在completionHandler被调用前释放，那么completionHandler就不能正常的运作了。在一般的单线程环境中，这种问题出现的可能性不大，但是到了多线程环境，就很不好说了，所以我们需要继续完善这个方法。</p>
<p>为了保证在Block内能够访问到正确的myController，我们在block内新定义一个强引用strongMyController来指向weakMyController指向的对象，这样多了一个强引用，就能保证这个myController对象不会在completionHandler被调用前释放掉了。于是，我们对代码再次做出修改：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
</td>
<td>
<div>
<div><code>MyViewController&nbsp;*myController&nbsp;=&nbsp;[[MyViewController&nbsp;alloc]&nbsp;init&hellip;];</code></div>
<div><code>//&nbsp;...</code></div>
<div><code>MyViewController&nbsp;*&nbsp;__weak&nbsp;weakMyController&nbsp;=&nbsp;myController;</code></div>
<div><code>myController.completionHandler&nbsp;=&nbsp;&nbsp;^(NSInteger&nbsp;result)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>MyViewController&nbsp;*strongMyController&nbsp;=&nbsp;weakMyController;</code></div>
<div>&nbsp;</div>
<div><code>　　</code><code>if</code>&nbsp;<code>(strongMyController)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>[strongMyController&nbsp;dismissViewControllerAnimated:YES&nbsp;completion:nil];</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>else</code>&nbsp;<code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;Probably&nbsp;nothing...</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>到此，一个完善的解决方案就完成了：）</p>
<p>官方文档对这个问题的说明到这里就结束了，但是可能很多朋友会有疑问，不是说不希望Block对原myController对象增加强引用么，这里为啥堂而皇之地在Block内新定义了一个强引用，这个强引用不会造成循环引用么？理解这个问题的关键在于理解被Block捕获的引用和在Block内定义的引用的区别。为了搞得明白这个问题，这里需要了解一些Block的实现原理，但由于篇幅的缘故，本文在这里就不展开了，详细的内容可以参考其他的文章，这里特别推荐<a href="http://blog.devtang.com/blog/2013/07/28/a-look-inside-blocks/" rel="external nofollow noreferrer">唐巧的文章</a>和另外2位作者的博文：<a href="http://blog.csdn.net/hherima/article/details/38586101" rel="external nofollow noreferrer">这个</a>和<a href="http://tanqisen.github.io/blog/2013/04/19/gcd-block-cycle-retain/" rel="external nofollow noreferrer">这个</a>，讲的都比较清楚。</p>
<p>这里假设大家已经对Block的实现原理有所了解了。我们就直入主题了！注意前方高能（=。=）</p>
<p>为了更清楚地说明问题，这里用一个简单的程序举例。比如我们有如下程序：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
</td>
<td>
<div>
<div><code>#include&nbsp;&lt;&nbsp;stdio.h&gt;</code></div>
<div>&nbsp;</div>
<div><code>int&nbsp;main()</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;b&nbsp;=&nbsp;10;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;*a&nbsp;=&nbsp;&amp;b;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void&nbsp;(^blockFunc)()&nbsp;=&nbsp;^(){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;*c&nbsp;=&nbsp;a;</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>};</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>blockFunc();</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>1;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>程序中，同为int型的指针，a是被Block捕获的变量，而c是在Block内定义的变量。我们用clang -rewrite-objc处理后，可以看到如下代码：</p>
<p>原main函数：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
</td>
<td>
<div>
<div><code>int&nbsp;main()</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;b&nbsp;=&nbsp;10;</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;*a&nbsp;=&nbsp;&amp;b;</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void&nbsp;(*blockFunc)()&nbsp;=&nbsp;(void&nbsp;(*)())&amp;__main_block_impl_0((void&nbsp;*)__main_block_func_0,&nbsp;&amp;__main_block_desc_0_DATA,&nbsp;a);</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>((void&nbsp;(*)(__block_impl&nbsp;*))((__block_impl&nbsp;*)blockFunc)-&gt;FuncPtr)((__block_impl&nbsp;*)blockFunc);</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>1;</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>Block的结构：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
</td>
<td>
<div>
<div><code>struct&nbsp;__main_block_impl_0&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__block_impl&nbsp;impl;</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__main_block_desc_0*&nbsp;Desc;</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>int&nbsp;*a;&nbsp;</code><code>//&nbsp;被捕获的引用&nbsp;a&nbsp;出现在了block的结构体里面</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>__main_block_impl_0(void&nbsp;*fp,&nbsp;struct&nbsp;__main_block_desc_0&nbsp;*desc,&nbsp;int&nbsp;*_a,&nbsp;int&nbsp;flags=0)&nbsp;:&nbsp;a(_a)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.isa&nbsp;=&nbsp;&amp;_NSConcreteStackBlock;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.Flags&nbsp;=&nbsp;flags;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.FuncPtr&nbsp;=&nbsp;fp;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>Desc&nbsp;=&nbsp;desc;</code></div>
<div><code>&nbsp;&nbsp;</code><code>}</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>实际执行的函数：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
</td>
<td>
<div>
<div><code>static&nbsp;void&nbsp;__main_block_func_0(struct&nbsp;__main_block_impl_0&nbsp;*__cself)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;</code><code>int&nbsp;*a&nbsp;=&nbsp;__cself-&gt;a;&nbsp;</code><code>//&nbsp;bound&nbsp;by&nbsp;copy</code></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int&nbsp;*c&nbsp;=&nbsp;a;&nbsp;</code><code>//&nbsp;在block中声明的引用&nbsp;c&nbsp;在函数中声明，存在于函数栈上</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>我们可以清楚得看到，a和c存在的位置完全不同，如果Block存在于堆上（在ARC下Block默认在堆上），那么a作为Block结构体的一个成员，也自然会存在于堆上，而c无论如何，永远位于Block内实际执行代码的函数栈内。这也导致了两个变量生命周期的完全不同：c在Block的函数运行完毕，即会被释放，而a呢，只有在Block被从堆上释放的时候才会释放。</p>
<p>回到我们的MyViewController的例子中，同上理，如果我们直接让Block捕获我们的myController引用，那么这个引用会被复制后（引用类型也会被复制）作为Block的成员变量存在于其所在的堆空间中，也就是为Block增加了一个指向myController对象的强引用，这就是造成循环引用的本质原因。对于MyViewController的例子，Block的结构体可以理解是这个样子：（准确的结构体肯定和以下这个有区别，但也肯定是如下这种形式：）</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
</td>
<td>
<div>
<div><code>struct&nbsp;__main_block_impl_0&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__block_impl&nbsp;impl;</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__main_block_desc_0*&nbsp;Desc;</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>MyViewController&nbsp;*&nbsp;__strong&nbsp;myController;&nbsp;&nbsp;</code><code>//&nbsp;被捕获的强引用myController</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>__main_block_impl_0(void&nbsp;*fp,&nbsp;struct&nbsp;__main_block_desc_0&nbsp;*desc,&nbsp;int&nbsp;*_a,&nbsp;int&nbsp;flags=0)&nbsp;:&nbsp;a(_a)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.isa&nbsp;=&nbsp;&amp;_NSConcreteStackBlock;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.Flags&nbsp;=&nbsp;flags;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.FuncPtr&nbsp;=&nbsp;fp;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>Desc&nbsp;=&nbsp;desc;</code></div>
<div><code>&nbsp;&nbsp;</code><code>}</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>而反观我们给Block传入一个弱引用weakMyController，这时我们Block的结构：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
</td>
<td>
<div>
<div><code>struct&nbsp;__main_block_impl_0&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__block_impl&nbsp;impl;</code></div>
<div><code>&nbsp;&nbsp;</code><code>struct&nbsp;__main_block_desc_0*&nbsp;Desc;</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>MyViewController&nbsp;*&nbsp;__weak&nbsp;weakMyController;&nbsp;&nbsp;</code><code>//&nbsp;被捕获的弱引用weakMyController</code></div>
<div><code>&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>__main_block_impl_0(void&nbsp;*fp,&nbsp;struct&nbsp;__main_block_desc_0&nbsp;*desc,&nbsp;int&nbsp;*_a,&nbsp;int&nbsp;flags=0)&nbsp;:&nbsp;a(_a)&nbsp;{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.isa&nbsp;=&nbsp;&amp;_NSConcreteStackBlock;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.Flags&nbsp;=&nbsp;flags;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>impl.FuncPtr&nbsp;=&nbsp;fp;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>Desc&nbsp;=&nbsp;desc;</code></div>
<div><code>&nbsp;&nbsp;</code><code>}</code></div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>再看在Block内声明的强引用strongMyController，它虽然是强引用，但存在于函数栈中，在函数执行期间，它一直存在，所以myController对象也一直存在，但是当函数执行完毕，strongMyController即被销毁，于是它对myController对象的强引用也被解除，这时Block对myController对象就不存在强引用关系了！加入了strongMyController的函数大体会是这个样子：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
</td>
<td>
<div>
<div><code>static&nbsp;void&nbsp;__main_block_func_0(struct&nbsp;__main_block_impl_0&nbsp;*__cself)&nbsp;{</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;</code><code>MyViewController&nbsp;*&nbsp;__strong&nbsp;strongMyController&nbsp;=&nbsp;__cself-&gt;weakMyController;&nbsp;</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&nbsp;....</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>综上所述，在ARC下（在MRC下会略有不同），Block捕获的引用和Block内声明的引用无论是存在空间与生命周期都是截然不同的，也正是这种不同，造成了我们对他们使用方式的区别。</p>
<p>以上就解释了之前提到的所有问题，希望大家能看明白：）</p>
<p>好的，最后再提一点，在ARC中，对Block捕获对象的内存管理已经简化了很多，由于没有了retain和release等操作，实际只需要考虑循环引用的问题就行了。比如下面这种，是没有内存泄露的问题的：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
</td>
<td>
<div>
<div><code>TestObject&nbsp;*aObject&nbsp;=&nbsp;[[TestObject&nbsp;alloc]&nbsp;init];</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>aObject.name&nbsp;=&nbsp;@</code><code>"hehe"</code><code>;</code></div>
<div>&nbsp;</div>
<div><code>self.aBlock&nbsp;=&nbsp;^(){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NSLog(@</code><code>"aObject's&nbsp;name&nbsp;=&nbsp;%@"</code><code>,aObject.name);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>};</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>我们上面提到的解决方案，只是针对Block产生循环引用的问题，而不是说所有的Block捕获引用都要这么处理，一定要注意！</p>
<h2>ARC与Toll-Free Bridging</h2>
<hr />
<blockquote><p>There are a number of data types in the Core Foundation framework and the Foundation framework that can be used interchangeably. This capability, called&nbsp;toll-free bridging, means that you can use the same data type as the parameter to a Core Foundation function call or as the receiver of an Objective-C message.</p></blockquote>
<p>Toll-Free Briding保证了在程序中，可以方便和谐的使用Core Foundation类型的对象和Objective-C类型的对象。详细的内容可参考<a href="https://developer.apple.com/library/ios/documentation/General/Conceptual/CocoaEncyclopedia/Toll-FreeBridgin/Toll-FreeBridgin.html" rel="external nofollow noreferrer">官方文档</a>。以下是官方文档中给出的一些例子：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
</td>
<td>
<div>
<div><code>NSLocale&nbsp;*gbNSLocale&nbsp;=&nbsp;[[NSLocale&nbsp;alloc]&nbsp;initWithLocaleIdentifier:@</code><code>"en_GB"</code><code>];</code></div>
<div><code>CFLocaleRef&nbsp;gbCFLocale&nbsp;=&nbsp;(CFLocaleRef)&nbsp;gbNSLocale;</code></div>
<div><code>CFStringRef&nbsp;cfIdentifier&nbsp;=&nbsp;CFLocaleGetIdentifier&nbsp;(gbCFLocale);</code></div>
<div><code>NSLog(@</code><code>"cfIdentifier:&nbsp;%@"</code><code>,&nbsp;(NSString&nbsp;*)cfIdentifier);</code></div>
<div><code>//&nbsp;logs:&nbsp;"cfIdentifier:&nbsp;en_GB"</code></div>
<div><code>CFRelease((CFLocaleRef)&nbsp;gbNSLocale);</code></div>
<div><code>&nbsp;</code>&nbsp;</div>
<div><code>CFLocaleRef&nbsp;myCFLocale&nbsp;=&nbsp;CFLocaleCopyCurrent();</code></div>
<div><code>NSLocale&nbsp;*&nbsp;myNSLocale&nbsp;=&nbsp;(NSLocale&nbsp;*)&nbsp;myCFLocale;</code></div>
<div><code>[myNSLocale&nbsp;autorelease];</code></div>
<div><code>NSString&nbsp;*nsIdentifier&nbsp;=&nbsp;[myNSLocale&nbsp;localeIdentifier];</code></div>
<div><code>CFShow((CFStringRef)&nbsp;[@</code><code>"nsIdentifier:&nbsp;"</code>&nbsp;<code>stringByAppendingString:nsIdentifier]);</code></div>
<div><code>//&nbsp;logs&nbsp;identifier&nbsp;for&nbsp;current&nbsp;locale</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>在MRC时代，由于Objective-C类型的对象和Core Foundation类型的对象都是相同的release和retain操作规则，所以Toll-Free Bridging的使用比较简单，但是自从ARC加入后，Objective-C类型的对象内存管理规则改变了，而Core Foundation依然是之前的机制，换句话说，Core Foundation不支持ARC。</p>
<p>这个时候就必须要要考虑一个问题了，在做Core Foundation与Objective-C类型转换的时候，用哪一种规则来管理对象的内存。显然，对于同一个对象，我们不能够同时用两种规则来管理，所以这里就必须要确定一件事情：哪些对象用Objective-C（也就是ARC）的规则，哪些对象用Core Foundation的规则（也就是MRC）的规则。或者说要确定对象类型转换了之后，内存管理的ownership的改变。</p>
<blockquote><p>If you cast between Objective-C and Core Foundation-style objects, you need to tell the compiler about the ownership semantics of the object using either a cast (defined in&nbsp;<code>objc/runtime.h</code>) or a Core Foundation-style macro (defined in<code>NSObject.h</code>)</p></blockquote>
<p>于是苹果在引入ARC之后对Toll-Free Bridging的操作也加入了对应的方法与修饰符，用来指明用哪种规则管理内存，或者说是内存管理权的归属。</p>
<p>这些方法和修饰符分别是：</p>
<h3><strong>__bridge（修饰符）</strong></h3>
<p>只是声明类型转变，但是不做内存管理规则的转变。</p>
<p>比如：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>CFStringRef&nbsp;s1&nbsp;=&nbsp;(__bridge&nbsp;CFStringRef)&nbsp;[[NSString&nbsp;alloc]&nbsp;initWithFormat:@</code><code>"Hello,&nbsp;%@!"</code><code>,&nbsp;name];</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>只是做了NSString到CFStringRef的转化，但管理规则未变，依然要用Objective-C类型的ARC来管理s1，你不能用CFRelease()去释放s1。</p>
<h3><strong><code>__bridge_retained（修饰符）</code>&nbsp;or&nbsp;<code>CFBridgingRetain（函数）</code></strong></h3>
<p>表示将指针类型转变的同时，将内存管理的责任由原来的Objective-C交给Core Foundation来处理，也就是，将ARC转变为MRC。</p>
<p>比如，还是上面那个例子</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>NSString&nbsp;*s1&nbsp;=&nbsp;[[NSString&nbsp;alloc]&nbsp;initWithFormat:@</code><code>"Hello,&nbsp;%@!"</code><code>,&nbsp;name];</code></div>
<div><code>?CFStringRef&nbsp;s2&nbsp;=&nbsp;(__bridge_retained&nbsp;CFStringRef)s1;</code></div>
<div><code>?</code><code>//&nbsp;do&nbsp;something&nbsp;with&nbsp;s2</code></div>
<div><code>//...</code></div>
<div><code>?CFRelease(s2);&nbsp;</code><code>//&nbsp;注意要在使用结束后加这个</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>我们在第二行做了转化，这时内存管理规则由ARC变为了MRC，我们需要手动的来管理s2的内存，而对于s1，我们即使将其置为nil，也不能释放内存。</p>
<p>等同的，我们的程序也可以写成：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>NSString&nbsp;*s1&nbsp;=&nbsp;[[NSString&nbsp;alloc]&nbsp;initWithFormat:@</code><code>"Hello,&nbsp;%@!"</code><code>,&nbsp;name];</code></div>
<div><code>?CFStringRef&nbsp;s2&nbsp;=&nbsp;(CFStringRef)CFBridgingRetain(s1);</code></div>
<div><code>?</code><code>//&nbsp;do&nbsp;something&nbsp;with&nbsp;s2</code></div>
<div><code>//...</code></div>
<div><code>?CFRelease(s2);&nbsp;</code><code>//&nbsp;注意要在使用结束后加这个</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<h3><strong><code>__bridge_transfer（修饰符）</code>&nbsp;or&nbsp;<code>CFBridgingRelease（函数）</code></strong></h3>
<p>这个修饰符和函数的功能和上面那个__bridge_retained相反，它表示将管理的责任由Core Foundation转交给Objective-C，即将管理方式由MRC转变为ARC。</p>
<p>比如：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
</td>
<td>
<div>
<div><code>CFStringRef&nbsp;result&nbsp;=&nbsp;CFURLCreateStringByAddingPercentEscapes(.&nbsp;.&nbsp;.);</code></div>
<div><code>?NSString&nbsp;*s&nbsp;=&nbsp;(__bridge_transfer&nbsp;NSString&nbsp;*)result;</code></div>
<div><code>//or&nbsp;NSString&nbsp;*s&nbsp;=&nbsp;(NSString&nbsp;*)CFBridgingRelease(result);</code></div>
<div><code>?</code><code>return</code>&nbsp;<code>s;</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>这里我们将result的管理责任交给了ARC来处理，我们就不需要再显式地将CFRelease()了。</p>
<p>对了，这里你可能会注意到一个细节，和ARC中那个4个主要的修饰符（__strong,__weak,...）不同，这里修饰符的位置是放在类型前面的，虽然官方文档中没有说明，但看官方的头文件可以知道。小伙伴们，记得别把位置写错哦：）</p>
<p><img referrerpolicy="no-referrer"src="http://cc.cocimg.com/api/uploads/image/20150206/1423188109714234.png" /></p>
<p>呼~ 好了，以上就是本篇文章的主要内容。</p>
<p>转自：<a href="http://www.cocoachina.com/ios/20150206/11121.html" rel="external nofollow noreferrer">http://www.cocoachina.com/ios/20150206/11121.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8knd768.html">《玩转D语言系列》三、轻松大跃进，把它当C语言先用起来</a>
		</li>
						<li><a href="https://www.batexi.com/a/r933jdr9.html">时间管理的若干Tips</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw20vyq.html">Delphi -- Compiler helper for initializing&sol;finalizing variable</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmk119.html">淘宝&lpar;阿里百川&rpar;手机客户端开发日记第六篇 Service详解&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wdzoq.html">jedis操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1m53k9.html">在WP8项目中使用ARMASM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04l5wq.html">《JavaScript语言精髓与编程实践》读书笔记二</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03rwwq.html">java泛型方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmlmnl9.html">1 &amp;amp&semi; 167&period; Two Sum I &amp;amp&semi; II &lpar; Input array is sorted &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl3mk9.html">&lbrack;google面试CTCI&rsqb; 2-1&period;移除链表中重复元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p7zv8.html">docker installation on ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo2ye9.html">pod command</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowdd1q.html">VS注释快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gzzpq.html">AOP 技术原理&mdash;&mdash;代理模式全面总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yyz2q.html">网络爬虫之网站图片爬取-python实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rl5539.html">mysql 由decimal 引起的 Warning&colon; Data truncated for column</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2lkvz9.html">HDU 2147 kiki&amp;&num;39&semi;s game&lpar;博弈经典题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r0r608.html">android填满手机内存的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjj4pp8.html">unity-------------------打包BuildAssetBundles的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp3w1y9.html">Java反射机制 &mdash;&mdash; 简单了解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1j3m5q.html">IE6兼容问题并解决总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eov6xq.html">查询oracle版本信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jp5v49.html">Scala的第一步</a>
			</li>
						<li><a href="https://www.batexi.com/a/495j4lvq.html">excel表数据对比  个人收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9656jjq.html">Bootstrap CSS概览代码文字标注篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93n0yrq.html">推荐几款实用的Android Studio 插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/495wxw09.html">tab标签切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z41pv9.html">如何快速在当前目录打开cmd命令提示符</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvr21z8.html">mov和ldr&sol;str的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1lrk08.html">Android Studio安装插件GsonFormat</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
